#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <libporty/net/network.h>
#include "tcurses.h"
#include "test_common.h"

const char *user_search[] = {"tcurses_termcap", NULL};

#define exec0(name) \
do { \
	tcurses_ ## name (term); \
} while(0)

#define exec1(name) \
do { \
	exec_setup(1); \
	tcurses_ ## name (term, a[0]); \
} while(0)

#define exec2(name) \
do { \
	exec_setup(2); \
	tcurses_ ## name (term, a[0], a[1]); \
} while(0)

#define exec3(name) \
do { \
	exec_setup(3); \
	tcurses_ ## name (term, a[0], a[1], a[2]); \
} while(0)

int main(int argc, char *argv[])
{
	FILE *f = stdin;
	tcurses_term_t *term = NULL;
	char *end, *cmd, *args, line[1024];

	tcurses_cap_search_user = user_search;

	while(!(feof(f))) {
		*line = '\0';
		fgets(line, sizeof(line), f);
		cmd = line;
		while(isspace(*cmd)) cmd++;
		end = strpbrk(cmd, "\r\n");
		if (end != '\0')
			*end = '\0';
		args = strpbrk(cmd, " \t");
		if (args != NULL) {
			*args = '\0';;
			args++;
		}
		if (strcmp(cmd, "init") == 0) {
			term = tcurses_init(1, args, 80, 25);
			if (term == NULL) {
				fprintf(stderr, "ERROR: can't initialize '%s'\n", args);
				exit(1);
			}
		}
		else if (strcmp(cmd, "write") == 0)
			tcurses_write(term, args);
		else if (strcmp(cmd, "flush") == 0)
			exec0(flush);
		else if (strcmp(cmd, "clear") == 0)
			exec0(clear);
		else if (strcmp(cmd, "cursor") == 0)
			exec2(cursor);
		else if (strcmp(cmd, "gotoxy") == 0)
			exec2(gotoxy);
		else if (strcmp(cmd, "setattr") == 0)
			exec3(setattr);
	}
	return 0;
}
